<script lang="ts">
import Vue from 'vue';
import { getPageMetadata } from '../../common/meta';
import { NextStep } from '../../components/common/index.vue';
import {
  Conduct,
  Careers,
  EventsSchedule,
  LightningHero,
  Section,
  Intro,
} from '../../components/events/index.vue';
import { KubeconLightingTalk } from '../../components/events/kubecon/index.vue';
import { CONTENT_TYPES } from '../../common/content-types';
import { getClient } from '~/plugins/contentful.js';
import {
  standardEventsDataHelper,
  EventData,
} from '~/services/events/events.service';

export default Vue.extend({
  components: {
    LightningHero,
    Intro,
    Section,
    KubeconLightingTalk,
    EventsSchedule,
    Careers,
    Conduct,
    NextStep,
  },
  nuxtI18n: false,
  async asyncData() {
    const content: EventData = await getClient()
      .getEntries({
        content_type: CONTENT_TYPES.EVENT,
        include: 10,
        'sys.id': '1TEUJXzYD3Y27yY8hLWOMZ',
      })
      .then((query: any) => {
        const entryFields = query.items[0]?.fields;
        return standardEventsDataHelper(entryFields);
      })
      .catch(console.error);
    return { content };
  },
  head() {
    return getPageMetadata((this as any).content.metadata, this.$route.path);
  },
});
</script>

<template>
  <div>
    <LightningHero v-if="content.hero" :data="content.hero" />
    <Intro v-if="content.description" :data="content.description" />
    <Section
      v-for="(item, index) in content.booth"
      :key="index"
      :class="{ reverse: index % 2 !== 0 }"
      class="slp-pb-32"
      :data="item"
    />
    <div v-if="content.featuredContent">
      <KubeconLightingTalk
        v-for="feature in content.featuredContent"
        :key="feature.header"
        :data="feature"
      />
    </div>
    <Section
      v-for="socialEvent in content.social"
      :key="socialEvent.header"
      :icon="'celebrate-24px'"
      :has-gradient="true"
      class="slp-py-160"
      :data="socialEvent"
      :cropped="true"
    />
    <EventsSchedule :data="content.agenda" />
    <Careers v-if="content.careers" :data="content.careers" />

    <div v-if="content.footnote">
      <Conduct
        v-for="footnote in content.footnote"
        :key="footnote.header"
        :data="footnote"
      />
    </div>
    <NextStep :variant="content.nextSteps" />
  </div>
</template>
